
-- Author PaKettle July 2020
-- commands /searcher /NewSearch


SR = {}
SR.SearchTable = {}
SR.SearchSector = 0
SR.SearchOffset = 0
SR.SearchSystem = 0
SR.CurrentSector = 0
SR.SearchMode = "off"


function SR.SectorChange()
   if (SR.CurrentSector ~= GetCurrentSectorid()) then
      SR.CurrentSector = GetCurrentSectorid()
   end
   if SR.SearchMode == "ON" then 
   
      if (SR.SearchSector + SR.SearchOffset ) == (GetCurrentSectorid()) then
         SR.SearchSector = SR.SearchSector + 1
         SR.SearchTable[SR.SearchSystem] = SR.SearchSector
         gkini.WriteString("Searcher","Table" , spickle(SR.SearchTable))
      end
   
      if SR.SearchSector > 16*16 then 
         SR.SearchSector = 0
         SR.SearchMode = "off"
      else
         NavRoute.SetFinalDestination (SR.SearchSector + SR.SearchOffset )  
      end
   end
   
end

RegisterEvent( SR.SectorChange,"SECTOR_CHANGED")

function SR.SearchSetup()
   if SR.SearchMode == "off" then
      SR.SearchSystem = (GetSystemID( GetCurrentSectorid() ) -1)
      SR.SearchTable = unspickle(gkini.ReadString("Searcher" , "Table" , "")) or {}

      SR.SearchSector = SR.SearchTable[SR.SearchSystem] or 0
      --print ("current sys= " .. SR.SearchSystem .. " Start Sector =" ..SR.SearchSector)
      if SR.SearchSector == nil then SR.SearchSector = 0 end
       -- only init if sector = 0 or system is different   
       
      if SR.SearchSector == 0  then
         print("Beginning new search")
         SR.SearchSector = 1 
      end
      SR.SearchOffset = SR.SearchSystem * 16 * 16
      SR.SearchMode = "ON"
      print("Engaging Search Mode")
      SR.SectorChange()
   else
      SR.SearchMode = "off"
      print(" Leaving Search Mode")
   end
end

RegisterUserCommand('searcher',SR.SearchSetup)

function SR.NewSetup()
   SR.SearchSystem = (GetSystemID( GetCurrentSectorid() ) -1)
   SR.SearchTable = unspickle(gkini.ReadString("Searcher" , "Table" , "")) or {}
   SR.SearchSector =  1
   print("Beginning new search")
   SR.SearchOffset = SR.SearchSystem * 16 * 16
   SR.SearchMode = "ON"
   SR.SectorChange()
end

RegisterUserCommand('NewSearch',SR.NewSetup)


